/*============================================================================
̧ٖ	: $Workfile: touch_lib_k.h $
	: ATMEL ڐGĳ ײ
ړI	: ײ؊֐ƕϐ̒`
ײ	: v1
------------------------------------------------------------------------------
Ŕԍ		: $Revision: 1 $
ŏIXV	: $Date: 2010-05-21 16:49:27+00:00 $
XV		: $Author: PC $
------------------------------------------------------------------------------
쌠 (c) 2008-2010 Atmel Ltd. S\ς
------------------------------------------------------------------------------
̧قATMEL Ltd̏̔閧܂݂܂BATMEL̋ŏꂽ\A
vf͂ǂȈӖ܂͂ǂȖړIɂǂȌ`ł̕`B邱ƂS
܂B
============================================================================*/

#ifndef TOUCH_LIB_K_H
#define TOUCH_LIB_K_H

/*----------------------------------------------------------------------------
  qɂꂽݸٰ ̧
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  : ײؔł̑I
------------------------------------------------------------------------------
QTouchײ؂͏[dԂ͈̔͂Ƌɍ\zċ܂B[dԂ͏[dAVR
瑪eʓֈړ]ԂłBZ[dԂ͂荂ȑɋA
Aeʓւ̊SȈړ][dɂ͑邩܂B

[dԂ͈̔͂͂߂sۯxɓKłgp҂ɑI
B

ײؖ`<>_<>_<cX>_<@\>.r90łB

Ⴆ΁Am88_8qt_c3_krs.r90ATmega88(m88)A8QTouchق(8qt)A3
[d(c3)AƉ]Ɛx(krs)łB

eʐsɂ́A\I0.25s`2.5ŝ悤ȏ[dԂKvƂ܂B
ȉ̕\͸ۯx͈̔͂ɑΉ[dԂ܂B

ۯx(MHz)	ۯ(s)	K[d
-------------	-------------	---------------------
	 1				1			1` 2 (1s`2s)
	 2				0.5			1` 5 (0.5s`2.5s)
	 4				0.25		1`10 (0.25s`2.5s)
	 8				0.125		2`10 (0.25s`1.25s)
	10				0.1			3`25 (0.3s`2.5s)
	16				0.0625		4`25 (0.25s`1.5625s)
	20				0.05		5`50 (0.25s`2.5s)
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  萔
----------------------------------------------------------------------------*/

/*
* ײ؂ɂĎxڐGِ
* ײ؂͂̒lpč\zĂāA͕ύXׂł͂܂B
*/
#define QT_NUM_CHANNELS 8u

/*
* ײ؂ɂĎx]܂͐̍ő吔
* ײ؂͂̒lpč\zĂāA͕ύXׂł͂܂B
*/
#define QT_MAX_NUM_ROTORS_SLIDERS 0u

/*
* \Ȋm̍ő吔񍐂̂ɕKv޲Đ
*/
#define QT_NUM_SENSOR_STATE_BYTES ( ( QT_NUM_CHANNELS + 7 ) / 8 )

/*----------------------------------------------------------------------------
  ^`
----------------------------------------------------------------------------*/

typedef unsigned char uint8_t;		// Ȃ8ޯĒl
typedef unsigned short uint16_t;	// Ȃ16ޯĒl
typedef short int16_t;				// t16ޯĒl
typedef uint8_t threshold_t;		// m팟o臒lݒ肷镄Ȃ8ޯĐl

/*
* ꂩ̊m킪ꍇAKSQ
*
* NO_AKS_GROUP	= mAKSQɓ炸A꓾܂B
* AKS_GROUP_x	= mAKSQxɓ܂B
*/
typedef enum tag_aks_group_t
{
	NO_AKS_GROUP,
	AKS_GROUP_1,
	AKS_GROUP_2,
	AKS_GROUP_3,
	AKS_GROUP_4,
	AKS_GROUP_5,
	AKS_GROUP_6,
	AKS_GROUP_7
} aks_group_t;

/* m킪 */
typedef enum tag_channel_t
{
	CHANNEL_0,
	CHANNEL_1,
	CHANNEL_2,
	CHANNEL_3,
	CHANNEL_4,
	CHANNEL_5,
	CHANNEL_6,
	CHANNEL_7
} channel_t;

/*
* m팟o˽ؼlB͊m팟o臒l%Ƃĕ\܂B
*
* HYST_x = ˽ؼl͌o臒lx%(؂̂Ċۂ)łB
* : ŏl2gp܂B
*
* :	o臒l=20ȂA
*		HYST_50		=10 (2050%)
*		HYST_25		= 5 (2025%)
*		HYST_12_5	= 2 (2012.5%)
*		HYST_6_25	= 2 (206.25%=1Al͋2)
*/
typedef enum tag_hysteresis_t
{
	HYST_50,
	HYST_25,
	HYST_12_5,
	HYST_6_25
} hysteresis_t;

/*
* mčZ臒lB͊m팟o臒l%Ƃĕ\܂B
*
* RECAL_x = čZ臒l͌o臒l%(؂̂Ċۂ)łB
* : ŏl4gp܂B
*
* :	o臒l=40ȂA
*		RECAL_100	=40 (40100%)
*		RECAL_50	=20 (4050%)
*		RECAL_25	=10 (4025%)
*		RECAL_12_5	= 5 (4012.5%)
*		RECAL_6_25	= 4 (406.25%=2Al4ɋ܂B)
*/
typedef enum tag_recal_threshold_t
{
	RECAL_100,
	RECAL_50,
	RECAL_25,
	RECAL_12_5,
	RECAL_6_25
} recal_threshold_t;

/*
* ]ƐɊւĕ񍐂px܂͈ʒu̕\
*
* RES_x_BIT = ]/񍐂xޯĒl
*
* : \RES_7_BIT̏ꍇA񍐂ʒu0`127͈̔͂łB
*/
typedef enum tag_resolution_t
{
	RES_1_BIT,
	RES_2_BIT,
	RES_3_BIT,
	RES_4_BIT,
	RES_5_BIT,
	RES_6_BIT,
	RES_7_BIT,
	RES_8_BIT
} resolution_t;

/* ײ؊m̏ */
typedef struct tag_qt_touch_status_t
{
	/*
	* ײ؊m̏(ON/OFF)
	* ޯ'n' = m'n'̏
	* ޯ0 = sensor_states[0] ޯ0
	* ޯ1 = sensor_states[0] ޯ1
	* `
	* ޯ7 = sensor_states[0] ޯ7
	* ޯ8 = sensor_states[1] ޯ0
	* ޯ9 = sensor_states[1] ޯ1
	* ` Ȃ
	* 0=oȂA1=oL
	*/
	uint8_t sensor_states[QT_NUM_SENSOR_STATE_BYTES];

	/*
	* ]px܂͐ʒu
	* ̒lsensor_statesΉ]܂͐oꂽƂ
	* ɗLłB
	*/
	uint16_t rotor_slider_values[QT_MAX_NUM_ROTORS_SLIDERS];
} qt_touch_status_t;

/*----------------------------------------------------------------------------
  ϸ
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Oϐ
----------------------------------------------------------------------------*/

extern qt_touch_status_t qt_touch_status;	// ײ؊m̏

/* SڐGm`Ԑݒ --------------------------------------*/

/*
* m팟oϕ(DI)*
* l:4
*/
extern uint8_t qt_di;

/*
* mϓێ
* P:200ms
* l:20 (oo4bԕϓh~)
*/
extern uint8_t qt_drift_hold_time;

/*
* mőON
* P:200ms (A150=30bɍčZ)A0=čZȂ
* l:0 (čZ֎~)
*/
extern uint8_t qt_max_on_duration;

/*
* m핉ϓx
* P:200ms
* l:20 (LSB4b)
*/
extern uint8_t qt_neg_drift_rate;

/*
* m퐳ϓx
* P:200ms
* l:5 (LSB1b)
*/
extern uint8_t qt_pos_drift_rate;

/*
* mčZ臒l
*
* : RECAL_50 (čZ臒l=o臒l50%)
*/
extern recal_threshold_t qt_recal_threshold;

/* ڐGmް ------------------------------------------------------*/

extern uint16_t channel_signals[QT_NUM_CHANNELS];		// eقő肳ꂽM
extern uint16_t channel_references[QT_NUM_CHANNELS];	// eقɑ΂M
extern int16_t sensor_deltas[QT_NUM_CHANNELS];			// (ق琬邩Ȃ)emł̐M()

/* gpҊ֐pp ------------------------------------------------*/

/*
* ̊֐ײ؂eʐsAǂ炪OɌĂ΂
* ܂Bgp҂͑肵Mlhg֐Kp邽߂ɂ̈pgp邱
* Ƃł܂B
*/
extern void (*qt_filter_callback)( void );

/*============================================================================
O : qt_enable_key
------------------------------------------------------------------------------
ړI : m틖
 : channel				= m킪gpڐG
	   aks_group			= ǂꂩ̏ꍇɊm킪AKSQ
	   detect_threshold		= m팟o臒l
	   detect_hysteresis	= m팟o˽ؼl
o : Ȃ
 : ɑΉ銴mԍ͊m킪ꂽԂɈˑ܂Bŏɋ
	   ꂽm킪m0A2ڂm1AȉlłB

	   ݂̌̏(ON/OFF)qt_touch_status.sensor_statesŒׂ邱Ƃł
	   ܂B
============================================================================*/

void qt_enable_key( channel_t channel,
					aks_group_t aks_group,
					threshold_t detect_threshold,
					hysteresis_t detect_hysteresis );

/*============================================================================
O : qt_init_sensing
------------------------------------------------------------------------------
ړI : ڐGm
 : Ȃ
o : Ȃ
 : KvȂǂ̊m̊֐Ă΂O(qt_enable_xxx()gp)
	   Ȃ΂Ȃ܂B

	   ̊֐͓ײؕϐvZĐڐGق`Ԑݒ肵AĂ
	   qt_measure_sensors()̑OɌĂ΂Ȃ΂Ȃ܂B
============================================================================*/

void qt_init_sensing( void );

/*============================================================================
O : qt_measure_sensors
------------------------------------------------------------------------------
ړI : ڐGm푪
 : current_time_ms = msł̌ݎ
o : Ȃ
 : ̊֐͋ꂽSĂ̊mŗeʐs܂Bemɑ
	   đ肵M͂̌Ɏgp҂̐ڐGAJA]pxł̕ύXA
	   ʒuł̕ύXȂǂ𒲂ׂ邽߂ɏ܂B

	   ꂽSĂ̊m݂̌̏Ԃqt_touch_status\̂ŕ񍐂܂B

	   ̊֐ĂяoOɁA1ȏ̊m킪(qt_enable_xxx()p)
	   Aqt_init_sensing()Ă΂ĂȂ΂Ȃ܂B
============================================================================*/

void qt_measure_sensors( uint16_t current_time_ms );

/*============================================================================
O : qt_calibrate_sensing
------------------------------------------------------------------------------
ړI : ڐGmZ
 : Ȃ
o : Ȃ
 : ̊֐͋ꂽSĂ̊m̍Z܂B

	   ͗ႦΉp`Ԃ̕ύXőSĂ̊m̑S̓IȍčZ]ޏꍇ
	   ɗLp܂B
============================================================================*/

void qt_calibrate_sensing( void );

/*============================================================================
O : qt_reset_sensing
------------------------------------------------------------------------------
ړI : ڐGmؾ
 : Ȃ
o : Ȃ
 : ̊֐͋ꂽSĂ̊m֎~ASĂײؕϐ(Ⴆqt_di)
	   ̊lɖ߂܂B

	   ͊m𓮓IɍČ`Ԑݒ肷ꍇɗLpł蓾܂B̊֐ďo
	   AKvȂǂ̊mċAĂqt_measure_channels()Ă΂
	   Oqt_init_sensing()Ă΂Ȃ΂Ȃ܂B
============================================================================*/

void qt_reset_sensing( void );

#endif /* TOUCH_LIB_K_H */
